Unit QSMKR_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, GSU1R_p;

procedure QSMKR(var RINT :Real; N :Integer; var A :Array of Real;
                var B :Array of Real; F :Func_F1A; E :Real);

implementation

procedure QSMKR(var RINT :Real; N :Integer; var A :Array of Real;
                var B :Array of Real; F :Func_F1A; E :Real);
var
I,ISEED,K,K1,N1,NM :Integer;
D,D1,R,S,T,Y,Z,E1 :Real;
V :Array [0..19] of Real;
X :Array [0..19] of Real;
label
_6,_7,_9,_11,_8,_10,_20,_30,_40,_50;
begin
K1 := N;
if ( N-3 ) < 0
 then goto _6
 else if ( N-3 ) > 0
       then goto _7
       else goto _6;
_6:
NM := Trunc(IntPower(10,N));
goto _8;
_7:
if ( N-7 ) < 0
 then goto _9
 else if ( N-7 ) > 0
       then goto _11
       else goto _9;
_9:
NM := 1000+Trunc(IntPower(3,N));
goto _8;
_11:
NM := 3000+Trunc(Power(2,N-5));
_8:
T := 0.0;
D := 0.0;
K := 0;
Z := 1.0;
for I:=1 to K1 do
 begin
  Z := (B[I-1] - A[I-1])*Z;
_10:
 end;
E1 := E/Z;
ISEED := K1;
_20:
GSU1R(ISEED,K1,V);
for I:=1 to K1 do
 begin
  X[I-1] := A[I-1] + (B[I-1] - A[I-1])*V[I-1];
_30:
 end;
R := F(X);
T := T + R;
K := K + 1;
S := T/K;
N1 := K - NM;
if ( N1 ) < 0
 then goto _20
 else if ( N1 ) > 0
       then goto _40
       else goto _20;
_40:
D := D + K/N1*IntPower(R - S,2);
D1 := D/N1;
Y := 3*Sqrt(D1/K);
if ( Y - E1*(1 + S) ) < 0
 then goto _50
 else if ( Y - E1*(1 + S) ) > 0
       then goto _20
       else goto _50;
_50:
RINT := S*Z;
end;

end.
